import math

def curry(f):
    return lambda x: (lambda *args: f(x, *args))

def gate(n, size, offset=0):
    return [1 if i == n else 0 for i in range(offset, offset+size)]

@curry
def orientedIntersection(l, sNew, sOld):
    left = max(sNew*l[0], sOld*l[1])
    right = min((sNew+1)*l[0], (sOld+1)*l[1])
    return max(right-left, 0)

@curry
def resample(newSize, distribution):
    oldSize = len(distribution)
    lcm = math.lcm(newSize, oldSize)
    intersection = orientedIntersection((lcm/newSize, lcm/oldSize))
    ratio = oldSize / newSize
    for i in range(newSize):
        yield oldSize/lcm*sum([distribution[j]*intersection(i, j)
                               for j in range(math.floor(i*ratio),
                                              math.ceil((i+1)*ratio))])
